<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_RentacarContract ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_RentacarContract extends AbstractStructArrayBase
{
    /**
     * The RentacarContract
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_RentacarContract[]
     */
    public $RentacarContract;
    /**
     * Constructor method for ArrayOfJP_RentacarContract
     * @uses ArrayOfJP_RentacarContract::setRentacarContract()
     * @param \StructType\JP_RentacarContract[] $rentacarContract
     */
    public function __construct(array $rentacarContract = array())
    {
        $this
            ->setRentacarContract($rentacarContract);
    }
    /**
     * Get RentacarContract value
     * @return \StructType\JP_RentacarContract[]|null
     */
    public function getRentacarContract()
    {
        return $this->RentacarContract;
    }
    /**
     * This method is responsible for validating the values passed to the setRentacarContract method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRentacarContract method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRentacarContractForArrayConstraintsFromSetRentacarContract(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_RentacarContractRentacarContractItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_RentacarContractRentacarContractItem instanceof \StructType\JP_RentacarContract) {
                $invalidValues[] = is_object($arrayOfJP_RentacarContractRentacarContractItem) ? get_class($arrayOfJP_RentacarContractRentacarContractItem) : sprintf('%s(%s)', gettype($arrayOfJP_RentacarContractRentacarContractItem), var_export($arrayOfJP_RentacarContractRentacarContractItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RentacarContract property can only contain items of type \StructType\JP_RentacarContract, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RentacarContract value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RentacarContract[] $rentacarContract
     * @return \ArrayType\ArrayOfJP_RentacarContract
     */
    public function setRentacarContract(array $rentacarContract = array())
    {
        // validation for constraint: array
        if ('' !== ($rentacarContractArrayErrorMessage = self::validateRentacarContractForArrayConstraintsFromSetRentacarContract($rentacarContract))) {
            throw new \InvalidArgumentException($rentacarContractArrayErrorMessage, __LINE__);
        }
        $this->RentacarContract = $rentacarContract;
        return $this;
    }
    /**
     * Add item to RentacarContract value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RentacarContract $item
     * @return \ArrayType\ArrayOfJP_RentacarContract
     */
    public function addToRentacarContract(\StructType\JP_RentacarContract $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_RentacarContract) {
            throw new \InvalidArgumentException(sprintf('The RentacarContract property can only contain items of type \StructType\JP_RentacarContract, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RentacarContract[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_RentacarContract|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_RentacarContract|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_RentacarContract|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_RentacarContract|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_RentacarContract|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RentacarContract
     */
    public function getAttributeName()
    {
        return 'RentacarContract';
    }
}
